//云类
//dom:dom元素
//x:初始X坐标
//y:初始Y坐标
//xsp:初始X的移动速度

var Cloud = function(dom,x,y,xsp){
	
	//云的基本属性
	this.dom = dom;
	this.x = x;
	this.y = y;
	this.xsp = xsp;
	this.width = dom.offsetWidth;
	this.height = dom.offsetHeight;
	//当前延迟执行时间
	this.lazyFps = 0;
	//上升的高度
	this.up = 0;

}
Cloud.prototype = {
	//移动频率
	moveFps : 30,
	//Y坐标移动速度
	ysp : 5,
	//更新
	//gameInfo:游戏背景数据
	updata : function(gameInfo){
		//判断当前延迟执行时间是否等于移动频率
		if(this.lazyFps == this.moveFps){
			//X坐标移动
			this.x += this.xsp;
			
			//判断往上升
			if(this.up){
				this.y -= this.ysp;
				this.up -= this.ysp;
			}
			
			//判断边界
			if(this.x <= 0){
				this.x = 0;
				this.xsp *= -1;
			}
			else if(this.x >= gameInfo.width-this.width){
				this.x = gameInfo.width-this.width;
				this.xsp *= -1;
			}
			//判断云是否移除屏幕
			if(this.y <= 0){
				this.callback();
				return;
			}
			//置0
			this.lazyFps = 0;
			//移动
			this.updataMove();
		}
		//当前延迟执行时间增加
		this.lazyFps += 10;
	},
	//移动
	updataMove : function(){
		
		this.dom.style.left = this.x+'px';
		this.dom.style.top = this.y+'px';
	},
	//向上移动
	upMove : function(d){
		
		this.up = d;
	},
	//判断玩家是否站立在云上
	//player:玩家
	checkStand : function(player){
		//玩家已经站在云上
		if(player.cloud)return false;
		
		//判断
		if(player.x > this.x - player.width/2 && player.x < this.x + this.width - player.width/2){
			
			if(player.y + player.height >= this.y && player.y + player.height < this.y + player.ysp){
				return true;
			}
		}
		return false;
	},
	//回调函数
	callback : function(){}
	
}