//游戏控制类

var Game = {
	//玩家对象
	player : {},
	//云数组
	clouds : [],
	//游戏背景dom
	gameBg : {},
	//游戏背景数据
	gameInfo : {},
	//计时器ID
	processId : 0,
	//风速
	windSp : 0,
	//风速的提示dom
	windTip : {},
	//分数的dom
	scoreDom : {},
	//分数
	score : 0,
	//初始化
	init : function(){
		
		var img_url = ['player.png','cloud1.png','cloud2.png','cloud3.png'];
		
		this.gameBg = Tools.getDom('gameBg');
		this.gameInfo = {width:this.gameBg.offsetWidth,height:this.gameBg.offsetHeight};
		
		this.windTip = Tools.getDom('windDir');
		this.scoreDom = Tools.getDom('score');
		//加载图片，回调开始
		Tools.loadImgs(img_url,this.start,this);
	},
	//开始
	start : function(){
		//创建玩家
		this.createPlayer();
		//创建三朵云
		var count = 3,This = this;
		while(count--){this.createCloud();}
		//玩家站立在第一朵云上
		this.player.standCloud(this.clouds[0]);
		//绑定单击事件
		this.gameBg.onclick = function(e){This.click(e);}
		//动画开始
		this.process();
	},
	//创建玩家
	createPlayer : function(){
		
		var div = Tools.createDom('div','player'),This = this;
		this.gameBg.appendChild(div);
		
		this.player = new Player(div,this.gameInfo.width/2,50,0);
		this.player.createCloud = function(){
			while(This.clouds.length<3){This.createCloud();}
			This.gameBg.onclick = function(e){This.click(e);}
		};
		this.player.callback = function(){This.gameOver();};
		
		this.player.updataMove();
	},
	//创建云
	createCloud : function(){
		//随机的云种类，随机的云速度，随机的云方向
		var rndCloud = Math.floor(Math.random()*3+1),
			rndSp = Math.floor(Math.random()*3+1) + 2,
			dir = Math.floor(Math.random()*2);
		
		var div = Tools.createDom('div','cloud'+rndCloud);
		this.gameBg.appendChild(div);
		
		var cloud = new Cloud(div,this.gameInfo.width/2,this.player.y+this.player.height+(this.clouds.length*120),rndSp*(dir?dir:-1)),This = this;
		cloud.updataMove();
		
		cloud.callback = function(){
			Tools.arrayDel(This.clouds,this);

			This.gameBg.removeChild(this.dom);
		}
		
		this.clouds.push(cloud);
	},
	//动画处理
	process : function(){
		
		var This = this;
		//计时器开始
		this.processId = setInterval(function(){
			
			//移动云
			for(var i=0,l=This.clouds.length;i<l;i++){
				
				var c = This.clouds[i];
				if(!c)continue;
				//更新云
				c.updata(This.gameInfo);
				//判断玩家是否站立在云上
				if(c.checkStand(This.player)){
					//玩家站立在云上
					This.player.standCloud(c);
					//修改风的速度
					This.windSpCreate();
					//向上移动
					This.moveUp();
				}
			}
			
			//移动人
			This.player.updata(This.gameInfo);
			
		},10);
		
	},
	//修改风的速度
	windSpCreate : function(){
		//随机风速度
		var rnd = Math.floor(Math.random()*5+1);
		//随机风方向
		var dir = Math.floor(Math.random()*2+1);
		
		this.windSp = rnd*(dir==1?1:-1);
		this.windTip.innerHTML = "风向："+(this.windSp>0?"右":"左")+Math.abs(this.windSp);
	},
	//向上移动
	moveUp : function(){
		
		var index = Tools.arrayIndex(this.clouds,this.player.cloud);
		//玩家移动
		this.player.upMove(120 * index);
		//云移动
		for(var i=0,l=this.clouds.length;i<l;i++){
			
			this.clouds[i].upMove(120 * index);
		}
		
		this.score += index;
		this.scoreDom.innerHTML = "层数："+this.score;
	},
	//单击事件
	click : function(e){
		e = window.event || e;
		//解决冒泡
		var target = e.srcElement || e.target;
		if(target.id == 'startBtn')return false;
		//跳跃
		if(!this.player.isJump) {
			this.player.jump(this.windSp<0?this.windSp-1:this.windSp);
			this.gameBg.onclick = null;
		}
	},
	//游戏结束
	gameOver : function(){
		
		clearInterval(this.processId);
		
		Tools.getDom('startBtn').style.display = 'block';
		
		this.reset();
	},
	//重置
	reset : function(){
		
		this.gameBg.removeChild(this.player.dom);
		while(this.clouds[0]){
			this.gameBg.removeChild(this.clouds[0].dom);
			this.clouds.shift();
		}
		
		this.player  ={};
		this.clouds = [];
		this.gameBg = {};
		this.gameInfo = {};
		this.processId = 0;
		this.windSp = 0;
		this.windTip = {};
		this.scoreDom = {};
		this.score = 0;
		this.scoreDom.innerHTML = "层数："+this.score;
		this.windTip.innerHTML = "风向：无";
		
	}
	
}