//玩家类
//dom:dom元素
//x:初始X坐标
//y:初始Y坐标
//xsp:初始X的移动速度

var Player = function(dom,x,y,xsp){
	//玩家的基本属性
	this.dom = dom;
	this.x = x;
	this.y = y;
	this.width = dom.offsetWidth;
	this.height = dom.offsetHeight;
	this.xsp = xsp;
	//上升高度
	this.up = 0;
	//当前延迟执行时间
	this.lazyFps = 0;
	//是否跳跃中
	this.isJump = false;
	//站立的云
	this.cloud = null;
}
Player.prototype = {
	//执行频率
	moveFps : 30,
	//向下移动速度
	ysp : 8,
	//向上移动速度
	upSp : 5,
	//更新
	//gameInfo:游戏背景数据
	updata : function(gameInfo){
		//判断当前延迟执行时间是否等于执行频率
		if(this.lazyFps == this.moveFps){
			//移动，若站立在云上，跟云一起移动，若不是，自己移动
			this.x += this.cloud?this.cloud.xsp:this.xsp;
			//跳跃中，向下移动
			if(this.isJump)this.y += this.ysp;
			
			//判断往上升
			if(this.up){
				this.y -= this.upSp;
				this.up -= this.upSp;
				//上升完毕，创建云
				if(this.up <= 0)this.createCloud();
			}
			
			//跳跃中，判断边界
			if(this.isJump){
				
				if(this.x <= -1*this.width || this.x > gameInfo.width-this.width)this.callback();
				else if(this.y > gameInfo.height)this.callback();
			}
			//置0
			this.lazyFps = 0;
			//移动
			this.updataMove();
		}
		//当前延迟执行时间增加
		this.lazyFps += 10;
	},
	//移动
	updataMove : function(){
		
		this.dom.style.left = this.x+'px';
		this.dom.style.top = this.y+'px';
	},
	//跳跃
	jump : function(windSp){
		
		this.isJump = true;
		this.xsp = windSp;
		this.y = this.y+this.cloud.height;
		this.cloud = null;
	},
	//向上升
	upMove : function(d){
	
		this.up = d;
	},
	//站在云上
	standCloud : function(cloud){

		this.isJump = false;
		this.xsp = cloud.xsp;
		this.cloud = cloud;
	},
	//回调函数
	callback : function(){},
	//创建云
	createCloud : function(){}
	
}